using System;
using System.Collections.Generic;
using System.Text;
using Interfaces;

namespace Model
{
    public class RemoteDemo : System.MarshalByRefObject, IDemo
    {
        private string memory = "";

        public RemoteDemo()
        {
            Console.WriteLine("RemoteDemo()");
        }

        public RemoteDemo(string initvalue)
        {
            this.memory = initvalue;
            Console.WriteLine("RemoteDemo(string initvalue) initvalue=<" + initvalue + ">");
        }

        #region IDemo Members

        public string Memory
        {
            get
            {
                Console.WriteLine("RemoteDemo - Get Memory=<" + memory + ">");
                return memory;
            }
            set
            {
                Console.WriteLine("RemoteDemo - Set Memory=<" + value + "> fra <" + memory + ">");
                memory = value;
            }
        }

        public void Print(string msg)
        {
            Console.WriteLine("RemoteDemo - msg=<" + msg + ">");
        }

        public IDemo GetNewRemote(string initvalue)
        {
            Console.WriteLine("RemoteDemo - GetNewRemote initvalue=<" + initvalue + ">");
            IDemo nyObj = new RemoteDemo(memory + " R");
            return nyObj;
        }

        public IDemo GetNewSerialized(string initvalue)
        {
            Console.WriteLine("RemoteDemo - GetNewSerialized initvalue=<" + initvalue + ">");
            IDemo nyObj = new SerializedDemo(memory + " S");
            return nyObj;
        }

        public void PrintOnObject(IDemo demoObj)
        {
            Console.WriteLine("RemoteDemo - PrintOnObject kaldt  fra memory=<" + this.memory + ">  demoObj.Memory=<" + demoObj.Memory + ">");
            demoObj.Print("RemoteDemo - PrintOnObject - Print aktiveret fra objekt med memory=<" + this.memory + ">");
        }

        #endregion
    }
}
