using System;
using System.Collections.Generic;
using System.Text;
using Interfaces;

namespace Model
{
    [Serializable]
    public class SerializedDemo : IDemo
    {
        private string memory = "";

        public SerializedDemo()             // HUSK AT DER SKAL VRE EN DEFAULT CONSTRUCTOR
        {
            Console.WriteLine("SerializedDemo()");
        }
        public SerializedDemo(string initvalue)
        {
            this.memory = initvalue;
            Console.WriteLine("SerializedDemo(string initvalue) initvalue=<" + initvalue + ">");
        }

        #region IDemo Members

        public string Memory
        {
            get
            {
                Console.WriteLine("SerializedDemo - Get Memory=<" + memory + ">");
                return memory;
            }
            set
            {
                Console.WriteLine("SerializedDemo - Set Memory=<" + value + "> fra <" + memory + ">");
                memory = value;
            }
        }

        public void Print(string msg)
        {
            Console.WriteLine("SerializedDemo - msg=<" + msg + ">");
        }

        public IDemo GetNewRemote(string initvalue)
        {
            Console.WriteLine("SerializedDemo - GetNewRemote initvalue=<" + initvalue + ">");
            IDemo nyObj = new RemoteDemo(memory + " R");
            return nyObj;
        }

        public IDemo GetNewSerialized(string initvalue)
        {
            Console.WriteLine("SerializedDemo - GetNewSerialized initvalue=<" + initvalue + ">");
            IDemo nyObj = new SerializedDemo(memory + " S");
            return nyObj;
        }

        public void PrintOnObject(IDemo demoObj)
        {
            Console.WriteLine("RemoteDemo - PrintOnObject kaldt  fra memory=<" + this.memory + ">  demoObj.Memory=<" + demoObj.Memory + ">");
            demoObj.Print("RemoteDemo - PrintOnObject - Print aktiveret fra objekt med memory=<" + this.memory + ">");
        }

        #endregion
    }
}
